#include "capd/capdlib.h"
#include <iostream>
using namespace std;
using namespace capd;
using namespace capd::vectalg;
using namespace capd::matrixAlgorithms;

void covering()
{
	MaxNorm<IVector,IMatrix> Norm;
	
	IMap f = "var:x1,x2,y;"
			 "fun:0.1+2*x2+0.3*x1*y,0.05-2*x1,0.02+0.5*y+0.1*x1*y;";
	
	IVector N(3);
	for(int i=0;i<3;i++) N[i] = interval(-1,1);

	IMatrix DF = f[N];
	
	IMatrix A(2,2), B(1,1), C1(2,1), C2(1,2);
	
	A[0][0]  = DF[0][0]; A[0][1]  = DF[0][1]; C1[0][0] = DF[0][2];
	A[1][0]  = DF[1][0]; A[1][1]  = DF[1][1]; C1[1][0] = DF[1][2];
	C2[0][0] = DF[2][0]; C2[0][1] = DF[2][1]; B[0][0]  = DF[2][2];
	
	IVector zero(3); // after initiating, an IVector it filled with zeros
	interval r = Norm(f(zero));
	
	interval mA = interval(1.0)/Norm(gaussInverseMatrix(A));
	
	if(not (mA - Norm(C1) > 1.0+r)) return;
	if(not (Norm(B) + Norm(C2) < 1.0-r)) return;
	
	cout << "covering holds" << endl;
}

int main()
{
  	try
    {	
		covering();
    }
  	catch(exception& e)
    {
      cout << endl << "Exception caught: " << e.what() << endl;
    }
    return 0;
}